searchNodes=[{"doc":"This module implements a mix task whose main purpose is to update the version number of an Elixir application, with extra steps such as committing a git tag. This is a simple tool to automatically update the version number of an Elixir project in the mix.exs , commit the change and create and create a git tag based on the new version. Check out version_tasks for a more versatile solution. Installation Although this tool can be set as a dependency in you mix projects, is is rather intended to be used as a globally available command line tool. mix archive.install hex mix_version Breaking changes in version 2 The v2 is a partial rewrite where most checks are run before attempting to make any modification for the project. A few changes to how the tool should be used were implemented: The configuration of the tool from the config files is not supported anymore. This is to support the tool as a globally installed archive. When mix_version is not listed in the dependencies, Elixir would warn if a project contains configuration for an unknown application. The new configuration is provided by listing a :versioning from the project/0 callback of the mix.exs file. The --git-only option was dropped, as the tool will warn and prompt if some files are not checked in, allowing to fix those issues before any change is made to the mix.exs file and any commit/tag is created. Any unchecked change to the mix.exs file will prevent the tool to run. The :annotate option is now true by default, creating annotated tags. Configuration The configuration for v2 can be provided under :versioning from the project/0 callback of the project file: # in mix.exs def project do [ app : :my_app , version : &quot;1.2.3&quot; , # ... versioning : versioning ( ) ] end defp versioning do [ tag_prefix : &quot;release-&quot; , commit_msg : &quot;new version: %s&quot; , annotation : &quot;tag release-%s created with mix_version&quot; , annotate : true ] end In the commit message and annotation, any occurence of %s will be replaced by the new version number. The presence of %s is not mandatory. Configuration can be overriden by command line options. For instance, if :annotate is set to true in configuration, you can use the --no-annotate CLI flag to force it to be false . The following sample configuration is now unsupported and will be ignored. import Config # UNSUPPORTED AS OF v2.0.0 config :mix_version , tag_prefix : &quot;release-&quot; , commit_msg : &quot;new version: %s&quot; , annotation : &quot;tag release-%s created with mix_version&quot; , annotate : true Default configuration annotate : true commit_msg : &quot;new version %s&quot; annotation : &quot;new version %s&quot; tag_prefix : &quot;v&quot; Usage Call the command from within a mix project. With no options, you will be prompted for the new version number. mix version [options] Options Versions managed by Elixir follow the MAJOR.MINOR.PATCH scheme, with optionnaly a pre-release tag as in 1.0.0-rc2 . -M, --major boolean. Bump to a new major version. -m, --minor boolean. Bump to a new minor version. -p, --patch boolean. Bump the patch version. -a, --annotate boolean. Create an annotated git tag. -A, --annotation string. Define the tag annotation message, with all '%s' replaced by the new VSN. -c, --commit-msg string. Define the commit message, with all '%s' replaced by the new VSN. -n, --new-version string. Set the new version number. -x, --tag-prefix string. Define the tag prefix. When using the options to bump a part of the version, a pre-release tag will be dropped for a major or minor bump, whereas a patch bump will only remove this pre-release tag and keep the current patch number. Bump patch: 1.2.3-rc1 -&gt; 1.2.3 1.2.3 -&gt; 1.2.4 Bump minor: 1.2.3-rc1 -&gt; 1.3.0 1.2.3 -&gt; 1.3.0 Bump major: 1.2.3-rc1 -&gt; 2.0.0 1.2.3 -&gt; 2.0.0","ref":"Mix.Tasks.Version.html","title":"Mix.Tasks.Version","type":"task"},{"doc":"Helpers to read from the Mix project the app is called in.","ref":"MixVersion.Config.html","title":"MixVersion.Config","type":"module"},{"doc":"","ref":"MixVersion.Config.html#current_project/0","title":"MixVersion.Config.current_project/0","type":"function"},{"doc":"","ref":"MixVersion.Config.html#otp_app/1","title":"MixVersion.Config.otp_app/1","type":"function"},{"doc":"","ref":"MixVersion.Config.html#project_get/1","title":"MixVersion.Config.project_get/1","type":"function"},{"doc":"","ref":"MixVersion.Config.html#project_get/2","title":"MixVersion.Config.project_get/2","type":"function"},{"doc":"","ref":"MixVersion.Config.html#project_get/3","title":"MixVersion.Config.project_get/3","type":"function"},{"doc":"This module is a simple, ad-hoc interface to the Git CLI.","ref":"MixVersion.Git.html","title":"MixVersion.Git","type":"module"},{"doc":"","ref":"MixVersion.Git.html#add/2","title":"MixVersion.Git.add/2","type":"function"},{"doc":"","ref":"MixVersion.Git.html#check_tag_availability/2","title":"MixVersion.Git.check_tag_availability/2","type":"function"},{"doc":"","ref":"MixVersion.Git.html#commit/2","title":"MixVersion.Git.commit/2","type":"function"},{"doc":"","ref":"MixVersion.Git.html#get_repo/1","title":"MixVersion.Git.get_repo/1","type":"function"},{"doc":"","ref":"MixVersion.Git.html#get_unstaged/1","title":"MixVersion.Git.get_unstaged/1","type":"function"},{"doc":"","ref":"MixVersion.Git.html#installed?/0","title":"MixVersion.Git.installed?/0","type":"function"},{"doc":"","ref":"MixVersion.Git.html#path_relative_to/2","title":"MixVersion.Git.path_relative_to/2","type":"function"},{"doc":"","ref":"MixVersion.Git.html#relative_path!/2","title":"MixVersion.Git.relative_path!/2","type":"function"},{"doc":"","ref":"MixVersion.Git.html#relative_path/2","title":"MixVersion.Git.relative_path/2","type":"function"},{"doc":"","ref":"MixVersion.Git.html#tag/3","title":"MixVersion.Git.tag/3","type":"function"},{"doc":"Behaviour for mix version stages.","ref":"MixVersion.Stage.html","title":"MixVersion.Stage","type":"behaviour"},{"doc":"","ref":"MixVersion.Stage.html#c:applies?/1","title":"MixVersion.Stage.applies?/1","type":"callback"},{"doc":"","ref":"MixVersion.Stage.html#c:run/1","title":"MixVersion.Stage.run/1","type":"callback"},{"doc":"Stage that checks that the future Git tag does not already exist.","ref":"MixVersion.Stage.CheckGitTag.html","title":"MixVersion.Stage.CheckGitTag","type":"module"},{"doc":"Callback implementation for MixVersion.Stage.applies?/1 .","ref":"MixVersion.Stage.CheckGitTag.html#applies?/1","title":"MixVersion.Stage.CheckGitTag.applies?/1","type":"function"},{"doc":"Callback implementation for MixVersion.Stage.run/1 .","ref":"MixVersion.Stage.CheckGitTag.html#run/1","title":"MixVersion.Stage.CheckGitTag.run/1","type":"function"},{"doc":"Checks if any file in the project has changes that are not committed to Git. If the project's mix.exs file has unstagged changes, mix version will abort, refusing to go any further. If other files have changes, the app will prompt for confirmation to continue.","ref":"MixVersion.Stage.CheckUnstaged.html","title":"MixVersion.Stage.CheckUnstaged","type":"module"},{"doc":"Callback implementation for MixVersion.Stage.applies?/1 .","ref":"MixVersion.Stage.CheckUnstaged.html#applies?/1","title":"MixVersion.Stage.CheckUnstaged.applies?/1","type":"function"},{"doc":"Callback implementation for MixVersion.Stage.run/1 .","ref":"MixVersion.Stage.CheckUnstaged.html#run/1","title":"MixVersion.Stage.CheckUnstaged.run/1","type":"function"},{"doc":"Stage that creates a new Git commit with the updated mix.exs file and all other changes added to the Git index.","ref":"MixVersion.Stage.CommitChanges.html","title":"MixVersion.Stage.CommitChanges","type":"module"},{"doc":"Callback implementation for MixVersion.Stage.applies?/1 .","ref":"MixVersion.Stage.CommitChanges.html#applies?/1","title":"MixVersion.Stage.CommitChanges.applies?/1","type":"function"},{"doc":"Callback implementation for MixVersion.Stage.run/1 .","ref":"MixVersion.Stage.CommitChanges.html#run/1","title":"MixVersion.Stage.CommitChanges.run/1","type":"function"},{"doc":"Stage that checks if the git command is callable with System.cmd/3 .","ref":"MixVersion.Stage.DetectGitCommand.html","title":"MixVersion.Stage.DetectGitCommand","type":"module"},{"doc":"Callback implementation for MixVersion.Stage.applies?/1 .","ref":"MixVersion.Stage.DetectGitCommand.html#applies?/1","title":"MixVersion.Stage.DetectGitCommand.applies?/1","type":"function"},{"doc":"Callback implementation for MixVersion.Stage.run/1 .","ref":"MixVersion.Stage.DetectGitCommand.html#run/1","title":"MixVersion.Stage.DetectGitCommand.run/1","type":"function"},{"doc":"Finds the root path of the Git repository of the project, if any.","ref":"MixVersion.Stage.FindGitRepo.html","title":"MixVersion.Stage.FindGitRepo","type":"module"},{"doc":"Callback implementation for MixVersion.Stage.applies?/1 .","ref":"MixVersion.Stage.FindGitRepo.html#applies?/1","title":"MixVersion.Stage.FindGitRepo.applies?/1","type":"function"},{"doc":"Callback implementation for MixVersion.Stage.run/1 .","ref":"MixVersion.Stage.FindGitRepo.html#run/1","title":"MixVersion.Stage.FindGitRepo.run/1","type":"function"},{"doc":"Decides on the new version number from the passed CLI options.","ref":"MixVersion.Stage.GetNextVsn.html","title":"MixVersion.Stage.GetNextVsn","type":"module"},{"doc":"Callback implementation for MixVersion.Stage.applies?/1 .","ref":"MixVersion.Stage.GetNextVsn.html#applies?/1","title":"MixVersion.Stage.GetNextVsn.applies?/1","type":"function"},{"doc":"","ref":"MixVersion.Stage.GetNextVsn.html#bump/2","title":"MixVersion.Stage.GetNextVsn.bump/2","type":"function"},{"doc":"Callback implementation for MixVersion.Stage.run/1 .","ref":"MixVersion.Stage.GetNextVsn.html#run/1","title":"MixVersion.Stage.GetNextVsn.run/1","type":"function"},{"doc":"This stage checks for the output command and prints the version and exists if the flag is provided.","ref":"MixVersion.Stage.PrintAndStop.html","title":"MixVersion.Stage.PrintAndStop","type":"module"},{"doc":"","ref":"MixVersion.Stage.PrintAndStop.html#applies?/1","title":"MixVersion.Stage.PrintAndStop.applies?/1","type":"function"},{"doc":"","ref":"MixVersion.Stage.PrintAndStop.html#run/1","title":"MixVersion.Stage.PrintAndStop.run/1","type":"function"},{"doc":"Stage that creates a possibly annotated tag at the current Git HEAD.","ref":"MixVersion.Stage.TagGitHead.html","title":"MixVersion.Stage.TagGitHead","type":"module"},{"doc":"","ref":"MixVersion.Stage.TagGitHead.html#applies?/1","title":"MixVersion.Stage.TagGitHead.applies?/1","type":"function"},{"doc":"","ref":"MixVersion.Stage.TagGitHead.html#run/1","title":"MixVersion.Stage.TagGitHead.run/1","type":"function"},{"doc":"","ref":"MixVersion.Stage.TagGitHead.html#tag_name/1","title":"MixVersion.Stage.TagGitHead.tag_name/1","type":"function"},{"doc":"Stage that is responsible to write the mix.exs file with the new version number.","ref":"MixVersion.Stage.UpdateMixfile.html","title":"MixVersion.Stage.UpdateMixfile","type":"module"},{"doc":"Callback implementation for MixVersion.Stage.applies?/1 .","ref":"MixVersion.Stage.UpdateMixfile.html#applies?/1","title":"MixVersion.Stage.UpdateMixfile.applies?/1","type":"function"},{"doc":"","ref":"MixVersion.Stage.UpdateMixfile.html#git_enabled?/1","title":"MixVersion.Stage.UpdateMixfile.git_enabled?/1","type":"function"},{"doc":"Callback implementation for MixVersion.Stage.run/1 .","ref":"MixVersion.Stage.UpdateMixfile.html#run/1","title":"MixVersion.Stage.UpdateMixfile.run/1","type":"function"},{"doc":"Utiliy to run System.cmd/3 with :ok/:error tuples results.","ref":"MixVersion.SysCmd.html","title":"MixVersion.SysCmd","type":"module"},{"doc":"","ref":"MixVersion.SysCmd.html#exec/3","title":"MixVersion.SysCmd.exec/3","type":"function"},{"doc":"The &quot;token&quot; is the state of the command line execution, passed to and returned from all stages.","ref":"MixVersion.Token.html","title":"MixVersion.Token","type":"module"},{"doc":"","ref":"MixVersion.Token.html#new/2","title":"MixVersion.Token.new/2","type":"function"},{"doc":"","ref":"MixVersion.Token.html#put_current_vsn/2","title":"MixVersion.Token.put_current_vsn/2","type":"function"},{"doc":"","ref":"MixVersion.Token.html#put_git_cmd?/2","title":"MixVersion.Token.put_git_cmd?/2","type":"function"},{"doc":"","ref":"MixVersion.Token.html#put_git_repo/2","title":"MixVersion.Token.put_git_repo/2","type":"function"},{"doc":"","ref":"MixVersion.Token.html#put_next_vsn/2","title":"MixVersion.Token.put_next_vsn/2","type":"function"},{"doc":"","ref":"MixVersion.Token.html#put_opts/2","title":"MixVersion.Token.put_opts/2","type":"function"},{"doc":"","ref":"MixVersion.Token.html#t:t/0","title":"MixVersion.Token.t/0","type":"type"}]